import java.io.*;
import java.util.*;

class KMPPrefix{
    //IO-Kram (wei auch nicht wozu genau)
    private static DataOutputStream fout;
    //ausgabe => Ausgabezeichenfolge
    private static String ausgabe;

    //Was das wohl ist???
    public static void main(String[] args){
      	System.out.println("+----------------------+\n|  KMPPrefix-Dingsbums |\n| (C) 2007 Yves Radunz |\n+----------------------+\n");
	if (args.length!=2){
	    //ein paar unverstaendliche Informationen zur Verwendung
	    if (args.length>0) System.out.println("Es fehlen erforderliche Argumente!\n");
	    System.out.println("Syntax: Zeichenfolge Ausgabedatei");
	    System.out.println("Zeichenfolge    die zu verarbeitende Zeichenfolge");
	    System.out.println("Ausgabedatei    die Ziel-TeX-Datei (ggf. mit Endung)");
	    System.out.println(mulstr(80,"-"));
	    System.out.println("\nKontakt: radunz@mathematik.hu-berlin.de");
	    System.exit(-1); //Tschuess!!
	}
	//Wenn die Anzahl der Argumente stimmt, dann weiter arbeiten
	byte[] tmp=args[1].getBytes();
	//Ausgabe vorbereiten
	if (notTEX(tmp)){
	    args[1]+=".tex";
	    System.out.println("Ausgabedatei wurde auf "+args[1]+" gesetzt.");
	}
	File f2=new File(args[1]);
	try{
	    f2.createNewFile();
	}
	catch(IOException x){}
	try{
	    fout=new DataOutputStream(new FileOutputStream(f2));
	}
	catch(FileNotFoundException x){}
	String zeile="";
	System.out.println("Ausgabedatei wurde erstellt und ggf. ueberschrieben.");
	System.out.println("Ausgabe wird erzeugt.");
	ausgabe="\\documentclass{article}\n\\usepackage[german]{babel}\n\\usepackage{amsfonts}\n\\setlength{\\parindent}{0cm}\n\\setlength{\\oddsidemargin}{0cm}\n\\setlength{\\evensidemargin}{0cm}\n\\setlength{\\textwidth}{16cm}\n\\begin{document}";
	ausgabe+="\n$\\begin{array}{|"+mulstr(args[0].length()+1, "c|")+"}\n\\hline\n\\!l\\!&\\!";
	for(int i=1;i<args[0].length();i++)
	    ausgabe+=Integer.toString(i)+"\\!&\\!";
	ausgabe+=Integer.toString(args[0].length())+"\\!\\\\\\hline\n\\!P_l\\!&\\!";
	for(int i=0;i<args[0].length()-1;i++)
	    ausgabe+=args[0].charAt(i)+"\\!&\\!";
	ausgabe+=args[0].charAt(args[0].length()-1)+"\\!\\\\\\hline\n\\!\\pi(l)\\!&\\!0";
	int[] pi=new int[args[0].length()];
	pi[0]=-1;
	int k=-1;
	for( int l=1;l<pi.length; l++){
	    while (k>=0 && args[0].charAt(k+1)!=args[0].charAt(l))
		k=pi[k];
	    pi[l]=((args[0].charAt(k+1)==args[0].charAt(l))?++k:k);
	    ausgabe+="\\!&\\!"+Integer.toString(pi[l]+1);
	}
	ausgabe+="\\!\\\\\n\\hline\\end{array}$\n\\end{document}";

	//Ausgabe rausruelpsen
	try{
	    fout.write(ausgabe.getBytes(),0,ausgabe.length());
	}
	catch(IOException x){}
	System.out.println("Fertig.");
    }
    private static boolean notTEX(byte[] wert){
	//Endet die Datei auf ".tex"? (ohne Beachtung von Gross-/Kleinschreibung)
	int n=wert.length;
	if (n<5) return true;
	if (wert[n-4]!='.') return true;
	if (wert[n-3]!='t' && wert[n-3]!='T') return true;
	if (wert[n-2]!='e' && wert[n-2]!='E') return true;
	if (wert[n-1]!='x' && wert[n-1]!='X') return true;
	return false;
    }
    private static String mulstr(int n, String s){
	//Zeichenfolge verfielfachen
	if (n<=0) return "";
	String tmp=mulstr(n/2, s);
	return tmp+tmp+((n%2==1)?s:"");
    }
}